%define CLASSPATH "/opt/JSDK/lib/classes.zip:/opt/java/lib/classes.zip"
Summary: Leading World Wide Web server w/ Java Servlet support
Name: apache-jserv
Version: 1.2.5
%define jserv-version 0.9.9
Release: 3
Group: Networking/Daemons
Source: ftp://ftp.apache.org/apache/dist/apache_1.2.5.tar.gz
Source1: index.html
Source2: poweredby.gif
Source3: httpd.init
Source4: apache.log
Source5: ftp://java.apache.org/apache/java/dist/jserv%{jserv-version}.tar.gz
Source6: jserv.log
Patch: apache_1.2.4-rh.patch
Patch1: apache_1.2.4-ServerRoot.patch
Patch2:	apache-gdbm_auth-noproxy.patch
Patch3: apache-jserv-config.patch
Copyright: Freely distributable & usable
BuildRoot: /tmp/apache-jserv-root
Requires: /etc/mime.types
Prereq: /sbin/chkconfig
Packager: Jason Gilbert <jason@mantissa.com>
URL: http://java.apache.org

%description
Apache is a full featured web server that is freely available, and also
happens to be the most widely used.

In order to use servlets you must install the JDK and JSDK.
Then set the paths correctly in /etc/httpd/conf/srm.conf and
set ServletManual to 'Off'.

It is also necessary at this time to set the ServerName directive in
/etc/httpd/conf/httpd.conf.

%changelog

* Mon Feb 02 1998 Jason Gilbert <jason@scott.net>
- wasn't copying in logrotate.d stuff for jserv

* Mon Jan 26 1998 Jason Gilbert <jason@scott.net>

- first jserv version
- corrected the ServerRoot directive in the default redhat config
- turned on support for dbm_auth and disabled the proxy
- changed the apache manual installation dir to /home/httpd/html/apache_manual

* Tue Jan 06 1998 Erik Troan <ewt@redhat.com>

- updated to 1.2.5, which includes many security fixes

* Wed Dec 31 1997 Otto Hammersmith <otto@redhat.com>

- fixed overkill on http.init stop

* Wed Dec 31 1997 Erik Troan <ewt@redhat.com>

- added patch for backslash DOS attach

* Thu Nov 06 1997 Donnie Barnes <djb@redhat.com>

- added htdigest binary to file list

* Mon Nov 03 1997 Donnie Barnes <djb@redhat.com>

- made the default index.html be config(noreplace) so we no longer
  blow away other folks' index.html

* Wed Oct 29 1997 Donnie Barnes <djb@redhat.com>

- added chkconfig support
- added restart|status options to initscript
- renamed httpd.init to httpd

* Tue Oct 07 1997 Elliot Lee <sopwith@redhat.com>
- Redid spec file, patches, etc. from scratch.

%prep
%setup -a 5 -n apache_1.2.5
%patch -p1
%patch1 -p1
%patch2 -p1

# Jserv stuff
mv jserv%{jserv-version} jserv
# Patch to add mod_jserv and config items
%patch3 -p1

# this is just a kludge since the jserv dist has these files w/ exec. perm.
for I in mod_jserv.c CHANGES LICENSE README protocol.txt; do
   chmod 644 jserv/$I
done

mv jserv/mod_jserv.c src

%build
cd src
./Configure
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS"
make EXTRA_LIBS=-lcrypt -C ../support htpasswd htdigest

cd ../jserv
make CLASSPATH=%{CLASSPATH}

%install
rm -rf $RPM_BUILD_ROOT
for I in /usr/sbin /etc/httpd/conf /home/httpd/html /home/httpd/icons \
	/home/httpd/cgi-bin /usr/man/man1 /usr/man/man8 /usr/man/man1 \
	/var/log/httpd /etc/logrotate.d; do
	mkdir -p $RPM_BUILD_ROOT/$I
done

install -s -m755 src/httpd support/htdigest support/htpasswd \
	$RPM_BUILD_ROOT/usr/sbin

install -m755 support/dbmmanage.new $RPM_BUILD_ROOT/usr/sbin/dbmmanage

for I in httpd access srm; do
	install -m644 conf/$I.conf-dist $RPM_BUILD_ROOT/etc/httpd/conf/$I.conf
done

install -m644 support/httpd.8 $RPM_BUILD_ROOT/usr/man/man8/httpd.8
install -m644 support/htpasswd.1 $RPM_BUILD_ROOT/usr/man/man1/htpasswd.1
install -m644 icons/* $RPM_BUILD_ROOT/home/httpd/icons
install -m644 htdocs/apache_pb.gif $RPM_BUILD_ROOT/home/httpd/html

mkdir -p $RPM_BUILD_ROOT/home/httpd/html/apache_manual
cp -r htdocs/manual/* $RPM_BUILD_ROOT/home/httpd/html/apache_manual

install -m644 $RPM_SOURCE_DIR/poweredby.gif $RPM_SOURCE_DIR/index.html \
	$RPM_BUILD_ROOT/home/httpd/html

mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m755 $RPM_SOURCE_DIR/httpd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/httpd
for I in 0 1 2 6; do
	mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc$I.d
	ln -s ../init.d/httpd $RPM_BUILD_ROOT/etc/rc.d/rc$I.d/K15httpd
done
for I in 3 5; do
	mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc$I.d
	ln -s ../init.d/httpd $RPM_BUILD_ROOT/etc/rc.d/rc$I.d/S85httpd
done

install -m644 $RPM_SOURCE_DIR/apache.log $RPM_BUILD_ROOT/etc/logrotate.d/apache

#Jserv install
cd jserv
make PREFIX=$RPM_BUILD_ROOT/home/httpd install
install -m644 servlet.properties $RPM_BUILD_ROOT/etc/httpd/conf
install -m644 $RPM_SOURCE_DIR/jserv.log $RPM_BUILD_ROOT/etc/logrotate.d/jserv
mkdir -p $RPM_BUILD_ROOT/home/httpd/servlets

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add httpd

cat <<EODIRS

In order for servlets to work you must follow these steps:

1)  Install the JDK for your platform and the JSDK from Sun Microsystems.
2)  Set the paths correctly for the JDK and JSDK in /etc/httpd/conf/srm.conf.
3)  Set 'ServletManual' to 'Off' in /etc/httpd/conf/srm.conf or configure and
    compile the program in /usr/doc/apache-jserv-$RPM_PACKAGE_VERSION/manual.
4)  Set the 'ServerName' directive in /etc/httpd/conf/httpd.conf
5)  Place your servlets in /home/httpd/servlets and access them by
    http://hostname/servlets/servletname.
6)  Enjoy!!

EODIRS

%preun
if [ $1 = 0 ]; then
   /sbin/chkconfig --del httpd
fi

%files
/usr/sbin/httpd
/usr/sbin/dbmmanage
/usr/sbin/htpasswd
/usr/man/man8/httpd.8
/usr/sbin/htdigest
%config /etc/logrotate.d/apache
%config /etc/httpd/conf/access.conf
%config /etc/httpd/conf/srm.conf
%config /etc/httpd/conf/httpd.conf
%config /etc/rc.d/init.d/httpd
%config(missingok) /etc/rc.d/rc3.d/S85httpd
%config(missingok) /etc/rc.d/rc5.d/S85httpd
%config(missingok) /etc/rc.d/rc0.d/K15httpd
%config(missingok) /etc/rc.d/rc1.d/K15httpd
%config(missingok) /etc/rc.d/rc2.d/K15httpd
%config(missingok) /etc/rc.d/rc6.d/K15httpd
%dir /home/httpd
/home/httpd/icons
%dir /home/httpd/cgi-bin
%dir /home/httpd/html
%config(noreplace) /home/httpd/html/index.html
/home/httpd/html/apache_manual
/home/httpd/html/apache_pb.gif
/home/httpd/html/poweredby.gif
%dir /var/log/httpd

%doc jserv/CHANGES jserv/LICENSE jserv/README jserv/protocol.txt
%doc jserv/manual
%config /etc/httpd/conf/servlet.properties
%config /etc/logrotate.d/jserv
/home/httpd/classes
%dir /home/httpd/servlets
